(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/forms'), require('bootstrap-datepicker'), require('@angular/common')) :
	typeof define === 'function' && define.amd ? define(['exports', '@angular/core', '@angular/forms', 'bootstrap-datepicker', '@angular/common'], factory) :
	(factory((global['ngq-datepicker'] = {}),global.ng.core,global.ng.forms,null,global.ng.common));
}(this, (function (exports,core,forms,bootstrapDatepicker,common) { 'use strict';

var NGQ_DATETIME_VALUE_ACCESSOR = {
    provide: forms.NG_VALUE_ACCESSOR,
    useExisting: core.forwardRef(function () { return NgqDatepickerComponent; }),
    multi: true
};
var BASE_OPTION = { autoclose: true, format: 'dd/mm/yyyy' };
var THAI_OPTION = Object.assign({}, BASE_OPTION, { thaiyear: true });
var NgqDatepickerComponent = /** @class */ (function () {
    function NgqDatepickerComponent() {
        this.propagateChange = function (_) { };
        this.onTouched = function () { };
    }
    Object.defineProperty(NgqDatepickerComponent.prototype, "tabindexAttr", {
        get: function () {
            return this.tabindex === undefined ? '-1' : undefined;
        },
        enumerable: true,
        configurable: true
    });
    NgqDatepickerComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        jQuery(this.input.nativeElement).datepicker(THAI_OPTION);
        jQuery(this.input.nativeElement)
            .datepicker()
            .on('changeDate', function (e) {
            _this._date = e.date;
            _this.propagateChange(_this._date);
        });
        jQuery(this.input.nativeElement).datepicker('update', this._date);
        jQuery(this.input.nativeElement).prop('disabled', this._isDisabled);
    };
    NgqDatepickerComponent.prototype.writeValue = function (obj) {
        this._date = obj;
    };
    NgqDatepickerComponent.prototype.registerOnChange = function (fn) {
        this.propagateChange = fn;
    };
    NgqDatepickerComponent.prototype.registerOnTouched = function (fn) { };
    NgqDatepickerComponent.prototype.setDisabledState = function (isDisabled) {
        this._isDisabled = isDisabled;
    };
    return NgqDatepickerComponent;
}());
NgqDatepickerComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'ngq-datepicker',
                template: "<input #input type=\"text\">\n",
                styles: ["h1{color:red}"]
            },] },
];
NgqDatepickerComponent.ctorParameters = function () { return []; };
NgqDatepickerComponent.propDecorators = {
    "tabindex": [{ type: core.Input },],
    "input": [{ type: core.ViewChild, args: ['input',] },],
    "onTouched": [{ type: core.HostListener, args: ['blur',] },],
    "tabindexAttr": [{ type: core.HostBinding, args: ['attr.tabindex',] },],
};
var NgqDatepickerModule = /** @class */ (function () {
    function NgqDatepickerModule() {
    }
    return NgqDatepickerModule;
}());
NgqDatepickerModule.decorators = [
    { type: core.NgModule, args: [{
                imports: [common.CommonModule],
                declarations: [NgqDatepickerComponent],
                exports: [NgqDatepickerComponent]
            },] },
];
NgqDatepickerModule.ctorParameters = function () { return []; };

exports.NgqDatepickerModule = NgqDatepickerModule;
exports.ɵa = NgqDatepickerComponent;

Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngq-datepicker.umd.js.map
