import { Component, forwardRef, HostBinding, HostListener, Input, ViewChild, NgModule } from '@angular/core';
import { NG_VALUE_ACCESSOR } from '@angular/forms';
import 'bootstrap-datepicker';
import { CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
const NGQ_DATETIME_VALUE_ACCESSOR = {
    provide: NG_VALUE_ACCESSOR,
    useExisting: forwardRef(() => NgqDatepickerComponent),
    multi: true
};
const BASE_OPTION = { autoclose: true, format: 'dd/mm/yyyy' };
const THAI_OPTION = Object.assign({}, BASE_OPTION, { thaiyear: true });
class NgqDatepickerComponent {
    constructor() {
        this.propagateChange = _ => { };
        this.onTouched = () => { };
    }
    /**
     * @return {?}
     */
    get tabindexAttr() {
        return this.tabindex === undefined ? '-1' : undefined;
    }
    /**
     * @return {?}
     */
    ngAfterViewInit() {
        jQuery(this.input.nativeElement).datepicker(THAI_OPTION);
        jQuery(this.input.nativeElement)
            .datepicker()
            .on('changeDate', (e) => {
            this._date = e.date;
            this.propagateChange(this._date);
        });
        jQuery(this.input.nativeElement).datepicker('update', this._date);
        jQuery(this.input.nativeElement).prop('disabled', this._isDisabled);
    }
    /**
     * @param {?} obj
     * @return {?}
     */
    writeValue(obj) {
        this._date = obj;
    }
    /**
     * @param {?} fn
     * @return {?}
     */
    registerOnChange(fn) {
        this.propagateChange = fn;
    }
    /**
     * @param {?} fn
     * @return {?}
     */
    registerOnTouched(fn) { }
    /**
     * @param {?} isDisabled
     * @return {?}
     */
    setDisabledState(isDisabled) {
        this._isDisabled = isDisabled;
    }
}
NgqDatepickerComponent.decorators = [
    { type: Component, args: [{
                selector: 'ngq-datepicker',
                template: `<input #input type="text">
`,
                styles: [`h1{color:red}`]
            },] },
];
/** @nocollapse */
NgqDatepickerComponent.ctorParameters = () => [];
NgqDatepickerComponent.propDecorators = {
    "tabindex": [{ type: Input },],
    "input": [{ type: ViewChild, args: ['input',] },],
    "onTouched": [{ type: HostListener, args: ['blur',] },],
    "tabindexAttr": [{ type: HostBinding, args: ['attr.tabindex',] },],
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class NgqDatepickerModule {
}
NgqDatepickerModule.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule],
                declarations: [NgqDatepickerComponent],
                exports: [NgqDatepickerComponent]
            },] },
];
/** @nocollapse */
NgqDatepickerModule.ctorParameters = () => [];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * Generated bundle index. Do not edit.
 */

export { NgqDatepickerModule, NgqDatepickerComponent as ɵa };
//# sourceMappingURL=ngq-datepicker.js.map
